Bug 4248 - (int-139303) Enable features in Busybox to increase its tools GNU/Debian compatibility
(int-139303)
: Enable features in Busybox to increase its tools GNU/Debian compatibility
Status: RESOLVED WONTFIX
Product: Core
Busybox
: 5.0-beta2
: All Maemo
: Low enhancement with 9 votes (vote)
: ---
Assigned To: Turo Janka
: busybox-bugs
:
:
:
:
  Show dependency tree
 
Reported: 2009-04-01 21:07 UTC by Lucas Maneos
Modified: 2012-04-13 02:47 UTC (History)
4 users (show)

See Also:


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description Lucas Maneos (reporter) 2009-04-01 21:07:16 UTC
(This is following up on the discussion in bug 3951)

For the applets already enabled in maemo busybox, there are several currently
disabled features that would increase compatibility with GNU tools without
costing too much in terms of binary size.  This would reduce problems with
porting existing debian packages and increase shell script portability between
on-device and scratchbox environments.

The list of these features is (see also
http://wiki.maemo.org/Talk:Task:Busybox):

CONFIG_FEATURE_GUNZIP_UNCOMPRESS
CONFIG_FEATURE_TAR_BZIP2
CONFIG_FEATURE_TAR_COMPRESS
CONFIG_FEATURE_TAR_FROM
CONFIG_FEATURE_TAR_LONG_OPTIONS
CONFIG_FEATURE_TAR_UNAME_GNAME
CONFIG_FEATURE_DD_IBS_OBS
CONFIG_FEATURE_DF_INODE
CONFIG_FEATURE_ENV_LONG_OPTIONS
CONFIG_FEATURE_EXPAND_LONG_OPTIONS
CONFIG_FEATURE_FANCY_HEAD
CONFIG_FEATURE_INSTALL_LONG_OPTIONS
CONFIG_FEATURE_LS_FILETYPES
CONFIG_FEATURE_RMDIR_LONG_OPTIONS
CONFIG_FEATURE_FANCY_SLEEP
CONFIG_FEATURE_SPLIT_FANCY
CONFIG_FEATURE_STAT_FORMAT
CONFIG_FEATURE_TR_CLASSES
CONFIG_FEATURE_TR_EQUIV
CONFIG_FEATURE_UNEXPAND_LONG_OPTIONS
CONFIG_FEATURE_WC_LARGE
CONFIG_FEATURE_FIND_MMIN
CONFIG_FEATURE_FIND_EXEC
CONFIG_FEATURE_FIND_DELETE
CONFIG_FEATURE_XARGS_SUPPORT_CONFIRMATION
CONFIG_FEATURE_XARGS_SUPPORT_TERMOPT
CONFIG_FEATURE_XARGS_SUPPORT_ZERO_TERM
CONFIG_FEATURE_HWCLOCK_LONG_OPTIONS
CONFIG_FEATURE_MOUNT_VERBOSE
CONFIG_FEATURE_UMOUNT_ALL
CONFIG_FEATURE_PIDOF_SINGLE
CONFIG_FEATURE_PIDOF_OMIT
CONFIG_FEATURE_PS_WIDE

Already dealt with in other bugs:

CONFIG_FEATURE_TAR_OLDGNU_COMPATIBILITY (bug 4237)
CONFIG_FEATURE_XARGS_SUPPORT_QUOTES (bug 3951)
CONFIG_FEATURE_IPV6 (bug 419)

These would also be nice to have, although strictly speaking they shouldn't
have any impact on shell scripts:

CONFIG_FEATURE_VI_READONLY
CONFIG_FEATURE_VI_SETOPTS
CONFIG_FEATURE_VI_SET

With all of the above enabled the armel binary size increases by ~12K (255KiB
vs 243KiB, built on a 5.0-alpha SDK and based on busybox_1.10.2.legal-1osso16).
 CONFIG_FEATURE_IPV6 accounts for ~7K of those.
Comment 1 Andre Klapper maemo.org 2009-04-06 12:05:23 UTC
Thanks for the list!
Comment 2 Alan Bruce maemo.org 2009-06-17 19:32:37 UTC
Please do this! I would really like to see the following two things:
- TAR options, ESPECIALLY bzip2 compression included (CONFIG_FEATURE_TAR_BZIP2)
- Verbose mount! What a pain to try and figure out why something isn't mounting
when all you get is "Mount failed". (CONFIG_FEATURE_MOUNT_VERBOSE)
Comment 3 Lucas Maneos (reporter) 2009-07-16 14:04:07 UTC
These are enabled in beta 2:

CONFIG_FEATURE_TAR_FROM
CONFIG_FEATURE_TAR_LONG_OPTIONS
CONFIG_FEATURE_PIDOF_SINGLE
CONFIG_FEATURE_PIDOF_OMIT
Comment 4 Andre Klapper maemo.org 2009-07-28 13:42:47 UTC
So the requests in this report are to enable:

CONFIG_FEATURE_VI_READONLY
CONFIG_FEATURE_VI_SETOPTS
CONFIG_FEATURE_VI_SET
CONFIG_FEATURE_TAR_BZIP2
CONFIG_FEATURE_MOUNT_VERBOSE
Comment 5 Lucas Maneos (reporter) 2009-07-28 13:57:27 UTC
The remaining list of requested options is:

CONFIG_FEATURE_GUNZIP_UNCOMPRESS
CONFIG_FEATURE_TAR_BZIP2
CONFIG_FEATURE_TAR_COMPRESS
CONFIG_FEATURE_TAR_UNAME_GNAME
CONFIG_FEATURE_DD_IBS_OBS
CONFIG_FEATURE_DF_INODE
CONFIG_FEATURE_ENV_LONG_OPTIONS
CONFIG_FEATURE_EXPAND_LONG_OPTIONS
CONFIG_FEATURE_FANCY_HEAD
CONFIG_FEATURE_INSTALL_LONG_OPTIONS
CONFIG_FEATURE_LS_FILETYPES
CONFIG_FEATURE_RMDIR_LONG_OPTIONS
CONFIG_FEATURE_FANCY_SLEEP
CONFIG_FEATURE_SPLIT_FANCY
CONFIG_FEATURE_STAT_FORMAT
CONFIG_FEATURE_TR_CLASSES
CONFIG_FEATURE_TR_EQUIV
CONFIG_FEATURE_UNEXPAND_LONG_OPTIONS
CONFIG_FEATURE_WC_LARGE
CONFIG_FEATURE_FIND_MMIN
CONFIG_FEATURE_FIND_EXEC
CONFIG_FEATURE_FIND_DELETE
CONFIG_FEATURE_XARGS_SUPPORT_CONFIRMATION
CONFIG_FEATURE_XARGS_SUPPORT_TERMOPT
CONFIG_FEATURE_XARGS_SUPPORT_ZERO_TERM
CONFIG_FEATURE_HWCLOCK_LONG_OPTIONS
CONFIG_FEATURE_MOUNT_VERBOSE
CONFIG_FEATURE_UMOUNT_ALL
CONFIG_FEATURE_PS_WIDE

The CONFIG_FEATURE_VI_* ones can be ignored.  Would be nice to have but don't
affect compatibility where it matters (eg init or post-install scripts), and
most people who care would be using vim anyway.
Comment 6 Eero Tamminen nokia 2009-09-15 18:44:31 UTC
Andre, could you create an internal bug for this?

(It's a bit late for Fremantle, but let's see.)
Comment 7 Andre Klapper maemo.org 2009-09-16 19:42:17 UTC
Done.
Comment 8 Lucas Maneos (reporter) 2010-06-05 22:47:09 UTC
(In reply to comment #5)
> CONFIG_FEATURE_PS_WIDE

Scratch that one, it changes the argument handling logic so that unrecognised
options are no longer silently ignored but cause ps to fail (bug 10571).  As
far as I can tell without actually building it this is still the case with
busybox 1.16.x.
Comment 9 Eero Tamminen nokia 2010-06-07 10:25:20 UTC
(In reply to comment #8)
> (In reply to comment #5)
> > CONFIG_FEATURE_PS_WIDE
> 
> Scratch that one, it changes the argument handling logic so that unrecognised
> options are no longer silently ignored but cause ps to fail (bug 10571).  As
> far as I can tell without actually building it this is still the case with
> busybox 1.16.x.

Failing on unrecognized args is good.  If things break then, whatever is
depending on "ps" in scripts should be fixed to use something more sensible. 
And maybe "ps" could be fixed too (if the option is in POSIX)...
Comment 10 Andre Klapper maemo.org 2012-03-24 11:38:10 UTC
The Maemo 5 User Interface and Maemo 5 platform components (e.g. libraries)
used for the N900 are considered stable by Nokia and it seems that there are no
plans for official updates currently, hence nobody plans to work on this
enhancement/wishlist request. 
(And in case you feel like discussing this situation: Nokia Customer Care or
http://talk.maemo.org would be the place to do so as you will not reach Nokia
officials in this community bugtracker - though all of this is really no news.)

Reflecting this status by setting RESOLVED WONTFIX for this
enhancement/wishlist request (see
https://bugs.maemo.org/page.cgi?id=fields.html#status for status explanations).

There is a small chance for issues in those Maemo components that are open
source: Contributed patches could be included and made available in the Maemo 5
Community CSSU updates. 
The Maemo CSSU project is run by a small team of volunteers; see
http://wiki.maemo.org/CSSU for more information.
So in case that you can provide a patch that fixes the reported problem, please
feel encouraged to file a request under
https://bugs.maemo.org/enter_bug.cgi?product=Maemo%205%20Community%20SSU .
Please note: The Maemo CSSU project is not related in any way to Nokia.


( Tag for mass-deleting bugmail: [cleanup20120324] )
Comment 11 Alan Bruce maemo.org 2012-04-13 02:47:19 UTC
I strongly suggest installing the excellent Enhanced Busybox Shell package,
which upgrades the stock Busybox to a very current version (the releases have
been tracking upstream releases closely), enables features not enabled on the
stock Busybox, and fixes several of the bugs in the stock version. The
maintainer of this package has even submitted patches upstream and had at least
one accepted.

http://maemo.org/packages/view/busybox-power/